{{
gui_label.spin: Defines a gui label
Copyright (c) 2009 John Steven Denson
See MIT license terms below
}}

var
  long textptr                  '' pointer to label text
  word left                     '' left pixel position of element
  word top                      '' top pixel position of element
  word width                    '' pixel width of element -- set to 0 for default or auto size
  word height                   '' pixel height of element -- set to 0 for default or auto size
  word border                   '' border width - 0 for no border
  word bocolor                  '' bocolor for label border
  word bgcolor                  '' bgcolor for label
  word fgcolor                  '' fgcolor for label

obj d: "spiasm-lcd-65k"
    g: "gui_common"
  
pub init(textp,x,y,w,h)
{{
  label constructor - creates a label element
  @param textp  - pointer to text
  @param x  - left
  @param y  - top
  @param w  - width  use 0 for default size
  @param h  - height use 0 for default size
}}
  textptr := textp
  left  := x
  top   := y
  width := w
  ifnot h
    height := constant(g#DHEIGHT-1)
  else
    height:= h
  setBorder(0)
  setBorderColor(d#LIGHT_GRAY)
  setbgcolor(d#TRANSPARENT)
  setfgcolor(d#BLACK)

pub setBorder(v)  
  border := v  
  
pub getBorder
  return border

pub setBorderColor(v)  
  bocolor := v  
  
pub getBorderColor
  return bocolor
  
pub setText(v)
  textptr := v

pub setTop(v)
  top := v
  
pub setLeft(v)
  left := v

pub setWidth(v)
  width := v

pub setHeight(v)
  height := v

pub setBgColor(v)  
  bgcolor := v  
  
pub setFgColor(v)  
  fgcolor := v  
  
pub getText
  return textptr

pub getTop
  return top
  
pub getLeft
  return left

pub getWidth
  return width

pub getHeight
  return height

pub getBgColor  
  return bgcolor  
  
pub getFgColor  
  return fgcolor  
  
pub paint | n, h
  d.setbgcolor(bgcolor)
  d.setfgcolor(fgcolor)
  if bgcolor
    d.fillRectangle(bgcolor,left,top,width,height)
  if border
    d.drawRectangle(bocolor,left,top,width,height,border)
  if textptr
    d.drawString(textptr,left+constant(d#FONTWIDTH*1/5),top+constant(d#FONTHEIGHT*2/3))

   
{{
                            TERMS OF USE: MIT License                                                           

 Permission is hereby granted, free of charge, to any person obtaining a copy
 of this software and associated documentation files (the "Software"), to deal
 in the Software without restriction, including without limitation the rights
 to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 copies of the Software, and to permit persons to whom the Software is
 furnished to do so, subject to the following conditions:

 The above copyright notice and this permission notice shall be included in
 all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,ARISING FROM,
 OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 THE SOFTWARE.
}}
      