{{
spiasm-lcd: SPI interface to the Spark-fun Nokia knockoff LCD
Known to work with Phillips controller ... no Epson available for dev.
Copyright (c) 2009 by John Steven Denson (Jazzed)
See MIT license terms below
}}

{{
Test Code
}}
{
CON
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000

  SCS   = 27
  SCK   = 26
  SDIO  = 25
  SRST  = 24
  
OBJ
  'dbg: "PASDebug" '<---- Added for Debugger
  
PUB main | n, mx, my, slen, strn

  'dbg.start(31,30,@entry)
  'waitcnt(clkfreq/4+cnt)
  
  start(PHILIPS, SCK, SCS, SDIO, SRST)
  waitcnt(clkfreq/4+cnt)  

  setbgcolor(BLUE)
  setfgcolor(YELLOW)
  cls
  print(string($d,"Hello World!"))
  n:=75
  fillRectangle(NAVY,5,35,99,70)  
  drawRectangle(WHITE,5,35,99,70,1)  
  fillRectangle(BLACK,n+=5,9,5,15)  
  fillRectangle(DARK_GRAY,n+=5,9,5,15)  
  fillRectangle(GRAY,n+=5,9,5,15)  
  fillRectangle(LIGHT_GRAY,n+=5,9,5,15)  
  fillRectangle(WHITE_GRAY,n+=5,9,5,15)  
  fillRectangle(WHITEST_GRAY,n+=5,9,5,15)  
  fillRectangle(WHITE,n+=5,9,4,15)  
  fillRectangle(ORANGE,80,30,30,30)  
  drawRectangle(WHITE,80,30,30,30,1)
  setbgcolor(WHITE)
  setfgcolor(DARK_GREEN)
  print(string($d,"Hello World!"))
  fillRectangle(YELLOW,10,40,30,30)  
  fillRectangle(DARK_GREEN,56,40,15,15)  
  fillRectangle(GREEN,50,60,25,25)  
  fillRectangle(BLACK,100,65,20,20)  
  drawRectangle(WHITE,100,65,20,20,1)  
  fillRectangle(RED,20,90,25,25)  
  drawRectangle(CYAN,20,90,25,25,1)  
  fillRectangle(PINK,55,96,15,15)
  fillRectangle(MAGENTA,80,90,30,30)  
  drawRectangle(PINK,80,90,30,30,1)
  repeat
'}

OBJ
  fnt: "spi-lcd-font-5x9mono"
                 
CON

  COLS = 25
  ROWS = 14

  screensize = COLS * ROWS
  lastrow    = screensize - COLS

  FONTWIDTH  = 5
  FONTHEIGHT = 9
  FONTOFFSET = 4
      
VAR
  byte screen[screensize]
  word row, col, bgcolor, fgcolor, contrast, flag
     
CON
' screen geometry
  ROW_LENGTH    = 132
  COL_HEIGHT    = 132
  END_PAGE      = 132
  END_COL       = 130

' EPSON Controller Definitions
  DISON         = $AF
  DISOFF        = $AE
  DISNOR        = $A6
  DISINV        = $A7
  SLPIN         = $95
  SLPOUT        = $94
  COMSCN        = $BB
  DISCTL        = $CA
  PASET         = $75
  CASET         = $15
  DATCTL        = $BC
  RGBSET8       = $CE
  RAMWR         = $5C
  RAMRD         = $5D
  PTLIN         = $A8
  PTLOUT        = $A9
  RMWIN         = $E0
  RMWOUT        = $EE
  ASCSET        = $AA
  SCSTART       = $AB
  OSCON         = $D1
  OSCOFF        = $D2
  PWRCTR        = $20
  VOLCTR        = $81
  VOLUP         = $D6
  VOLDOWN       = $D7
  TMPGRD        = $82
  EPCTIN        = $CD
  EPCOUT        = $CC
  EPMWR         = $FC
  EPMRD         = $FD
  EPSRRD1       = $7C
  EPSRRD2       = $7D
  NOOP          = $25
   
' PHILIPS Controller Definitions
  NOOPP         = $00
  BSTRON        = $03
  SLEEPIN       = $10
  SLEEPOUT      = $11
  NORON         = $13
  INVOFF        = $20
  INVON         = $21
  SETCON        = $25
  DISPOFF       = $28
  DISPON        = $29
  CASETP        = $2A
  PASETP        = $2B
  RAMWRP        = $2C
  RGBSET        = $2D
  MADCTL        = $36
  COLMOD        = $3A
  DISCTR        = $B9
  DORNORM       = $BA
  DORSWAP       = $BB
  EC            = $C0
   
' 16-Bit Color Definitions
  TRANSPARENT   = 0    ' use for showChar showString to print chars without background
  WHITE         = %11111_111_111_11111
  BLACK         = %00000_000_001_00000 ' not really black, but better on screen ... 0 is TRANSPARENT
  RED           = %11111_000_000_00000
  GREEN         = %00000_111_111_00000
  DARK_GREEN    = %00000_101_100_00000
  BLUE          = %00000_000_000_11000
  CYAN          = %10100_101_000_11111
  MAGENTA       = %11010_000_000_11111
  YELLOW        = %11111_111_111_00100
  BROWN         = %10110_000_100_00100
  ORANGE        = %11111_101_111_00010
  PINK          = %11111_100_000_11111
  BEIGE         = %11110_110_000_11000
  NAVY          = %00001_000_000_10000
  'DARK_GRAY     = %00110_000_110_00110
  'GRAY          = %01010_001_110_01000
  DARK_GRAY     = %01000_010_000_00111
  GRAY          = %01111_011_100_01011
  LIGHT_GRAY    = %10100_100_111_01100
  WHITE_GRAY    = %10111_101_111_10011
  WHITEST_GRAY  = %11101_111_000_11010

  INIT_CONTRAST = $3e
  MAX_COLORS    = $FFFF
               
  PHILIPS       = 5
  EPSON         = 10

{
VAR
  long cog
  long mode, clock, chipsel, dapin, command, fnarr, fntab, buff[$10] ' could be bigger later for buff io
}

DAT
  cog         long 0
  mode        long 0
  clock       long 0
  chipsel     long 0
  dapin       long 0
  command     long 0
  fnarr       long 0
  fntab       long 0
  buff        long 0 [$18]
   
PUB start(cmode, pck, pcs, pdio, rst)
{{
  start device
  cmode is EPSON or PHILIPS
  pck is clock pin
  pcs is chip select pin
  pdio is data pin
}}

  bgcolor := WHITE
  fgcolor := BLUE
  
  mode    := cmode
  clock   := pck 
  chipsel := pcs
  dapin   := pdio
  
  clock   := |< pck 
  chipsel := |< pcs
  dapin   := |< pdio ' device input - output for cpu

  fnarr   := fnt.getFontArray
  fntab   := fnt.getFontTable

  outa[pck] := outa[pcs] := outa[pdio] := outa[rst] := 1
  dira[pck] := dira[pcs] := dira[pdio] := dira[rst] := 1

  outa[pck]~
  outa[pdio]~
  outa[pcs]~~

  waitcnt(clkfreq/20+cnt)
  outa[rst]~

  waitcnt(clkfreq/20+cnt)
  outa[rst]~~
  outa[pck]~~
  outa[pdio]~~

  waitcnt(clkfreq/20+cnt)

  dira[pck] := dira[pcs] := dira[pdio] := 0     ' release io pins

  cog := cognew(@entry, @mode) + 1
  waitcnt(clkfreq/20+cnt)
  
  ifnot cog
    return

  if mode == EPSON
    sendCommand(DISCTL)           ' epson
    sendData($0C)                 ' CL dividing ratio - no divide switch period $8
    sendData($20)
    sendData($00)
    sendData($01)
     
    sendCommand(COMSCN)           ' epson common scanning direction
    sendData($01)
      
    sendCommand(OSCON)            ' epson internal oscillator on
    sendCommand(SLPOUT)           ' epson sleep out

    sendCommand(PWRCTR)           ' epson power control
    sendData($0F)                 ' everything on no external reference resistors

    sendCommand(DISINV)           ' epson invert display mode
    'sendCommand(DISNOR)           ' epson normal display mode
     
    sendCommand(DATCTL)           ' epson data control
    sendData($03)
    sendData($00)                 ' normal RGB
    sendData($02)                 ' 16-bit grayscale type a

    sendCommand(NOOP)             ' epson NOOP
    waitcnt(clkfreq/20+cnt)
    sendCommand(DISON)            ' epson display on

  else 
    sendCommand(SLEEPOUT)         ' philips sleep out - exit power down
    sendCommand(BSTRON)           ' philips display voltage set on                           

    sendCommand(MADCTL)           ' philips memory access control
    sendData($C0)                 ' $C8 inverts top/bottom - $00/$08 inverts RGB
     
    sendCommand(COLMOD)           ' philips set color mode
    sendData($05)                 ' 2 8b/pixel, 3, 12b/pixel, 5 16b/pixel
     
    sendCommand(DORSWAP)          ' philips mem data order     
    sendCommand(NOOPP)            ' philips NOOP
    'pause
    sendCommand(DISPON)           ' philips display on
     
  ' philips contrast: $5f washout $38-$44 good, $20 very low
  setContrast(INIT_CONTRAST)

  return cog

pub stop
  cogstop(cog~ - 1)

pub sendCommand(val)
  buff := val
  command  := CMD_SEND_COMMAND
  repeat while command
    
pub sendData(val)
  buff := val
  command  := CMD_SEND_DATA
  repeat while command
  
{
pub sleep
{{
  Put LCD to sleep
}}
  if mode == EPSON
    sendCommand(SLPIN)           ' epson sleep in
  else
    'sendCommand(SLEEPIN)         ' phillips sleep in
    sendCommand(DISPOFF)
      
pub wakeup
{{
  Wake up LCD
}}
  if mode == EPSON
    sendCommand(SLPOUT)           ' epson sleep out
  else
    'sendCommand(SLEEPOUT)         ' phillips sleep out
    sendCommand(DISPON)         ' phillips sleep out
}
  
pub Clear(color)
{{
  Clear screen to the color value
}}
  buff := color
  command  := CMD_CLEAR_SCREEN
  repeat while command

pub setContrast(val)
{{
  set contrast for display
}}
  contrast := val
  if mode == EPSON
    sendCommand(VOLCTR)         ' epson electronic volume -- contrast/brightness
    sendData(val & $3f)         ' example had sendData($24)
    sendData((val & $c0) >> 5)  ' example had sendData($03)
  else  
    sendCommand(SETCON)         ' philips set contrast
    sendData(val)               ' contrast: $5f washout $38-$44 good, $20 very low

pub getContrast
{{
  get contrast for display
}}
  return contrast
  
pub setPixel(color, mx, my)
{{
  pixel at x,y to color value
}}
  long[@buff+0] := color
  long[@buff+4] := mx
  long[@buff+8] := my
  command       := CMD_SET_PIXEL
  repeat while command

pub dispChar(ch, fcolor, bcolor, mx, my)
{{
  put char ch with fcolor and bcolor to mx,my
  @param ch - char to put
  @param fcolor - char foreground color
  @param bcolor - char background color
  @param mx - char left position
  @param my - char top position
}}
  long[@buff+0]  := (ch-$20) // 95
  long[@buff+4]  := fcolor
  long[@buff+8]  := bcolor
  long[@buff+12] := mx
  long[@buff+16] := my
  command        := CMD_SHOW_CHAR
  repeat while command

pub drawString(s, mx, my) | n
{{
  draw string s with fgcolor and bgcolor to mx, my
  @param s - string to draw
  @param mx - left position
  @param my - top position
}}
  n~
  repeat strsize(s)
    dispChar(byte[s++], fgcolor, bgcolor, mx+n, my)
    n += fontwidth
    
pub fillRectangle(fcolor, mx, my, mw, mh)
{{
  fill rectangle with fcolor to mx,my,width,height
  @param fcolor - foreground color
  @param mx - char left position
  @param my - char top position
  @param mw - width
  @param mh - height
}}
  long[@buff+0]  := fcolor
  long[@buff+4]  := mx
  long[@buff+8]  := my
  long[@buff+12] := mw
  long[@buff+16] := mh
  long[@buff+20] := 0
  command        := CMD_FILL_RECT
  repeat while command

pub drawRectangle(fcolor, mx, my, mw, mh, olsize)
{{
  fill rectangle with fcolor to mx,my,width,height
  @param fcolor - foreground color
  @param mx - char left position
  @param my - char top position
  @param mw - width
  @param mh - height
}}
  long[@buff+0]  := fcolor
  long[@buff+4]  := mx
  long[@buff+8]  := my
  long[@buff+12] := mw
  long[@buff+16] := mh
  long[@buff+20] := olsize
  command        := CMD_FILL_RECT
  repeat while command

{
pub drawImage(imgp, mx, my, mw, mh, olsize)
{{
  fill rectangle with an image to mx,my,width,height
  @param imgp - image pointer
  @param mx - char left position
  @param my - char top position
  @param mw - width
  @param mh - height
}}
  long[@buff+0]  := imgp
  long[@buff+4]  := mx
  long[@buff+8]  := my
  long[@buff+12] := mw
  long[@buff+16] := mh
  long[@buff+20] := olsize
  command        := CMD_FILL_IMG
  repeat while command
}
  
PUB newline | n
  col~
  if ++row == rows
    row~
    bytemove(@screen, @screen[cols], lastrow)   'scroll lines
    bytefill(@screen[lastrow], " ", cols)       'clear new line
    repeat n from 0 to lastrow
      putch(screen[n])
    repeat cols-1
      dispChar(" ", fgcolor, bgcolor, col*fontwidth+fontoffset, row*fontheight+fontoffset)
      col++
    col~     

PUB cls
  row~
  col~
  bytefill(@screen, " ", screensize)
  clear(bgcolor)

PUB putch(c)
  screen[row * cols + col] := c
  if(c == $d)
    newline
  else
    dispChar(c, fgcolor, bgcolor, col*fontwidth+fontoffset, row*fontheight+fontoffset)
  if ++col == cols
    newline

PUB print(s) | n, ln
  ln := strsize(s) - 1
  repeat n from 0 to ln
    if(byte[s+n] == $d)
      newline
    else
      putch(byte[s+n])  

PUB printxy(mx,my,s) | n, ln
  col := mx // cols
  row := my // rows
  repeat strsize(s)
    putch(byte[s++])

PUB setxy(mx,my)
  col := mx // cols
  row := my // rows

PUB getx
  return col

PUB gety
  return row

PUB setfgcolor(c)
  fgcolor := c

PUB getfgcolor
  return fgcolor
  
PUB setbgcolor(c)
  bgcolor := c

PUB getbgcolor
  return bgcolor
  

PUB str(stringptr)

'' Print a zero-terminated string

  repeat strsize(stringptr)
    out(byte[stringptr++])


PUB dec(value) | i

'' Print a decimal number

  if value < 0
    -value
    out("-")

  i := 1_000_000_000

  repeat 10
    if value => i
      out(value / i + "0")
      value //= i
      result~~
    elseif result or i == 1
      out("0")
    i /= 10


PUB hex(value, digits)

'' Print a hexadecimal number

  value <<= (8 - digits) << 2
  repeat digits
    out(lookupz((value <-= 4) & $F : "0".."9", "A".."F"))


PUB bin(value, digits)

'' Print a binary number

  value <<= 32 - digits
  repeat digits
    out((value <-= 1) & 1 + "0")

PUB out(c) | i, k

'' Output a character
''
''     $00 = clear screen
''     $01 = home
''     $08 = backspace
''     $09 = tab (8 spaces per)
''     $0A = set X position (X follows)
''     $0B = set Y position (Y follows)
''     $0C = set color (color follows)
''     $0D = return
''  others = printable characters

  case flag
    $00: case c
           $00: cls
           $01: col := row := 0
           $08: if col
                  col--
           $09: repeat
                  putch(" ")
                while col & 7
           $0A..$0C: flag := c
                     return
           $0D: newline
           other: putch(c)
    $0A: col := c // cols
    $0B: row := c // rows
    $0C: fgcolor := c
  flag := 0

        
CON
  CMD_MASK          = $7f
  CMD_SEND_COMMAND  = $1
  CMD_SEND_DATA     = $2
  CMD_CLEAR_SCREEN  = $4
  CMD_SET_PIXEL     = $8
  CMD_SHOW_CHAR     = $10
  CMD_FILL_RECT     = $20
  'CMD_FILL_IMG      = $40 ' not implemented
      
DAT
''
''----------------------------------------------------------------------
''PASM code and interfaces  
''PASM HW interface uses only CLK, CS, DAT
''Reset and initialization to be done with external code and CMD_SEND COMMAND/DATA
''
entry         org 0

  'save for PASD debugger
  ' long $34FC1202,$6CE81201,$83C120B,$8BC0E0A,$E87C0E03,$8BC0E0A
  ' long $EC7C0E05,$A0BC1207,$5C7C0003,$5C7C0003,$7FFC,$7FF8

  mov         bp, par
  rdlong      mod,bp  ' driver mode
  add         bp, #4
  rdlong      clk,bp  ' clk pin bitmask
  add         bp, #4
  rdlong      cs, bp  ' cs pin  bitmask
  add         bp, #4
  rdlong      dio, bp ' dio pin  bitmask

  add         bp, #4
  mov         cp, bp  ' cmd ptr
  add         bp, #4
  mov         fntarr, bp  ' parameter ptr
  add         bp, #4
  mov         fnttab, bp  ' size ptr - use for screen dump later
  add         bp, #4  ' buffer base ptr

  ' init pins
  mov         csdclk, cs ' csdclk also used in bit xfers
  or          csdclk, dio
  or          csdclk, clk
  or          dira, csdclk   

cmdloop

  rdlong      cmd, cp wz
  if_z        jmp  #cmdloop
  
'switch cmd
' 
  test        cmd, #CMD_SEND_COMMAND wz
  if_nz       jmp  #cmdSendCommand

  test        cmd, #CMD_SEND_DATA    wz
  if_nz       jmp  #cmdSendData

  test        cmd, #CMD_SET_PIXEL    wz
  if_nz       jmp  #cmdSetPixel

  test        cmd, #CMD_CLEAR_SCREEN wz
  if_nz       jmp  #cmdClearScreen
  
  test        cmd, #CMD_SHOW_CHAR wz
  if_nz       jmp  #cmdShowChar

  test        cmd, #CMD_FILL_RECT wz
  if_nz       jmp  #cmdFillRect

'  test        cmd, #CMD_FILL_IMG wz
'  if_nz       jmp  #cmdFillImage

' command done
'
cmddone
  mov         cmd, #0
  wrlong      cmd, cp
  jmp   #cmdloop        



'----------------------------------------------------------------------  
'setColor for 4096 colors
' c1 := (color >> 4) & $ff
' c2 := ((color & $f) << 4) | (color >> 8)
' c3 := color & $ff
' @param pix - color to set
' @return c1,c2,c3
setColor
  mov         c1, pix
  shr         c1, #8  
  and         c1, #$ff
  mov         c2, pix
  and         c2, #$ff
setColor_ret  ret

''----------------------------------------------------------------------  
'' rd
'' @return acc - byte read
rd
  mov         acc,#0
  mov         len,#8
:nextrd
  andn        outa, clk
  xor         outa, clk
  test        dio, ina wc ' nice. saves an instruction -vs-
  addx        acc,acc     ' using "test wz, muxnz, and shl" ... .5us/byte
  djnz        len,#:nextrd wz
rd_ret        ret


''----------------------------------------------------------------------
'' snd
'' @param acc - byte to send
snd
  mov         len,#8
:nextsnd
  andn        outa, clk
  test        acc, #$80   wz ' send msbfirst
  muxnz       outa, dio
  shl         acc, #1
  xor         outa, clk
  djnz        len, #:nextsnd
  snd_ret     ret

''----------------------------------------------------------------------
'' sndcmd
'' @param acc - byte to send
sndcmd
  andn        outa, csdclk
  xor         outa, clk
  call        #snd
  or          outa,cs
sndcmd_ret       ret

''----------------------------------------------------------------------
'' snddat
'' @param acc - byte to send
snddat
  andn        outa, csdclk
  or          outa, dio ' set data bit
  xor         outa, clk
  call        #snd
  or          outa,cs
snddat_ret       ret


''----------------------------------------------------------------------  
''cmdSendCommand
'' set first bit 0 and send byte
'' @param byte to write in bufptr[0]
''
cmdSendCommand
  rdlong      acc, bp
  call        #sndcmd
  jmp         #cmddone

  
''----------------------------------------------------------------------  
''cmdSendData
'' set first bit 0 and send byte
'' @param byte to write in bufptr[0]
''
cmdSendData
  rdlong      acc, bp
  call        #snddat
  jmp         #cmddone


''----------------------------------------------------------------------  
''cmdClearScreen
'' @param pix color to clear in bufptr[0]
''
cmdClearScreen

  rdlong      pix, bp

  mov         x, #0
  mov         y, #0
  mov         width, #END_PAGE
  mov         height,#END_PAGE
  call        #setField
  call        #setColor

  mov         ctr, PAGE_PIXELS
  shr         ctr, #1
clrloop
  mov         acc, c1
  call        #snddat
  mov         acc, c2
  call        #snddat
  mov         acc, c1
  call        #snddat
  mov         acc, c2
  call        #snddat
  mov         acc, c1
  call        #snddat
  mov         acc, c2
  call        #snddat
  mov         acc, c1
  call        #snddat
  mov         acc, c2
  call        #snddat
  djnz        ctr, #clrloop
  
  jmp         #cmddone


''----------------------------------------------------------------------  
''setField - sets coordinates and field geometry
'' @param x left
'' @param y top 
'' @param width 
'' @param height
''
setField
  cmp         mod, EPSON wz
  if_ne       jmp  #setFieldPHILIPS

setFieldEPSON
  'sendCommand(PASET)
  'sendData(0)
  'sendData(END_PAGE-1)
  mov         acc, #CASET
  call        #sndcmd
  mov         acc, x
  call        #snddat
  add         acc, width
  call        #snddat

  'sendCommand(CASET)
  'sendData(0)
  'sendData(END_PAGE-1)
  mov         acc, #PASET
  call        #sndcmd
  mov         acc, y
  call        #snddat
  add         acc, height
  call        #snddat

  'sendCommand(RAMWR)
  mov         acc, #RAMWR
  call        #sndcmd

  jmp         setField_ret

setFieldPHILIPS
  'sendCommand(PASETP)
  'sendData(0)
  'sendData(END_PAGE-1)
  mov         acc, #CASETP
  call        #sndcmd
  mov         acc, x
  call        #snddat
  add         acc, width
  call        #snddat

  'sendCommand(CASETP)
  'sendData(0)
  'sendData(END_PAGE-1)
  mov         acc, #PASETP
  call        #sndcmd
  mov         acc, y
  call        #snddat
  add         acc, height
  call        #snddat

  'sendCommand(RAMWRP)
  mov         acc, #RAMWRP
  call        #sndcmd

setField_ret  ret


''----------------------------------------------------------------------  
'' multiply
'' @parm t1          term 1
'' @parm t2          term 2
'' @return rc        product
''
multiply
  mov         rc,#0
:loop
  shr         t1,#1   wc
  if_c  add   rc,t2
  shl         t2,#1
  tjnz        t1,#:loop
multiply_ret  ret


''----------------------------------------------------------------------  
''cmdSetPixel
'' same as cmdClearScreen except do one pixel
'' @param pix color to set in bufptr[0] ' long wide
'' @param x xposition in bufptr[1]      ' long wide
'' @param y xposition in bufptr[2]      ' long wide

cmdSetPixel
  call        #setPix
  jmp         #cmddone

'----------------------------------------------------------------------  
'setPix
' same as cmdSetPixel except its called
' @param pix color to set in bufptr[0] ' long wide
' @param x xposition in bufptr[1]      ' long wide
' @param y xposition in bufptr[2]      ' long wide

setPix
  mov         ctr, bp
  rdlong      pix, ctr
  add         ctr, #4
  rdlong      x,   ctr
  add         ctr, #4
  rdlong      y,   ctr

  ' x,y already set
  mov         width, x
  mov         height,y
  call        #setField

  call        #setColor
    
  mov         acc, c1
  call        #snddat
  mov         acc, c2
  call        #snddat
  
setPix_ret  ret


''----------------------------------------------------------------------  
''cmdFillRect
'' print from ch index with attributes     ' long wide
'' @param fcolor - foreground color        buf[0]
'' @param mx - left position               buf[1]
'' @param my - top position                buf[2]
'' @param width - rect width               buf[3]
'' @param height - rect height             buf[4]
'' @param outline - draw outline width     buf[5]

cmdFillRect

  mov         tp,  bp
  rdlong      pix, tp
  add         tp,  #4
  rdlong      x,   tp
  add         tp,  #4
  rdlong      y,   tp
  add         tp,  #4
  rdlong      width,tp
  add         tp,  #4
  rdlong      height,tp
  add         tp,  #4
  rdlong      outln,tp

  call        #fillRect
  call        #drawRect

  jmp         #cmddone

'----------------------------------------------------------------------  
'fillRect
' @param pix color to clear in buf[0]
' @param x left                buf[1]
' @param y top                 buf[2]
' @param width                 buf[3]
' @param height                buf[4]
'
fillRect
  tjnz        outln, #fillRect_ret
  mov         twid, width
  mov         thit, height
  add         width, x
  add         height,y
  mov         ty, thit
fillRecthloop
  call        #setField
  call        #setColor
  mov         tx, twid
  add         tx, #1
fillRectwLoop
  mov         acc, c1
  call        #snddat
  mov         acc, c2
  call        #snddat
  djnz        tx, #fillRectwLoop
  add         y, #1
  djnz        ty,#fillRecthloop
fillRect_ret ret

fillRectSP
  mov         sx, x
  mov         thit,height
fillRectYloop
  mov         twid,width
fillRectXloop
  mov         tp, bp
  wrlong      pix,tp
  add         tp, #4
  wrlong      x, tp
  add         tp, #4
  wrlong      y, tp
  add         tp, #4
  call        #setPix

  add         x, #1
  djnz        twid,#fillRectXloop
  add         y, #1
  mov         x, sx
  djnz        thit,#fillRectYloop

fillRectSP_ret  ret

'----------------------------------------------------------------------  
'drawRect
' @param pix color to clear in buf[0]
' @param x left                buf[1]
' @param y top                 buf[2]
' @param width                 buf[3]
' @param height                buf[4]
'
drawRect
  tjz         outln, #drawRect_ret
  mov         twid, width
  mov         thit, height
  add         width, x
  add         height,y
  mov         sx, x
  mov         sy, y
  
  call        #setField
  call        #setColor

' draw top line with outln height
  mov         ty, outln
drawRectThloop
  mov         tx, twid
  add         tx, #1
drawRectTwLoop
  mov         acc, c1
  call        #snddat
  mov         acc, c2
  call        #snddat
  djnz        tx, #drawRectTwLoop
  add         y, #1
  djnz        ty, #drawRectThloop

' draw left side
  mov         y, sy
  mov         ty, thit
drawRect1hloop
  call        #setField
  mov         tx, outln
drawRect1wLoop
  mov         acc, c1
  call        #snddat
  mov         acc, c2
  call        #snddat
  djnz        tx, #drawRect1wLoop
  add         y, #1
  djnz        ty, #drawRect1hloop

' draw right side
  mov         y, sy
  mov         x, sx
  add         x, twid
  sub         x, outln
  add         x, #1

  mov         ty, thit
drawRect2hloop
  call        #setField
  mov         tx, outln
drawRect2wLoop
  mov         acc, c1
  call        #snddat
  mov         acc, c2
  call        #snddat
  djnz        tx, #drawRect2wLoop
  add         y, #1
  djnz        ty,#drawRect2hloop

' draw bottom line with outln height
  mov         y, sy
  add         y, thit
  sub         y, outln
  'sub         y, #1
  mov         x, sx
  call        #setField
  
  mov         ty, outln
drawRectBhloop
  mov         tx, twid
  add         tx, #1
drawRectBwLoop
  mov         acc, c1
  call        #snddat
  mov         acc, c2
  call        #snddat
  djnz        tx, #drawRectBwLoop
  add         y, #1
  djnz        ty, #drawRectBhloop
drawRect_ret ret


''----------------------------------------------------------------------  
''cmdFillImage
'' display an image                     ' long wide
'' @param img - image pointer              buf[0]
'' @param mx - left position               buf[1]
'' @param my - top position                buf[2]
'' @param width - image width              buf[3]
'' @param height - image height            buf[4]
'' @param outline - draw outline width     buf[5]

cmdFillImage
  mov         tp,  bp
  rdlong      pix, tp
  add         tp,  #4
  rdlong      x,   tp
  add         tp,  #4
  rdlong      y,   tp
  add         tp,  #4
  rdlong      width,tp
  add         tp,  #4
  rdlong      height,tp
  add         tp,  #4
  rdlong      outln,tp wz

  call        #fillImage
  if_nz call  #drawRect

  jmp         #cmddone

''----------------------------------------------------------------------  
''fillImage
'' @param image pointer in      buf[0]
'' @param x left                buf[1]
'' @param y top                 buf[2]
'' @param width                 buf[3]
'' @param height                buf[4]
''
fillImage
  mov         twid, width
  mov         thit, height
  add         width, x
  add         height,y
  mov         ty, thit
fillImagehloop
  call        #setField
  call        #setColor
  mov         tx, twid
  add         tx, #1
fillImagewLoop
  mov         acc, c1
  call        #snddat
  mov         acc, c2
  call        #snddat
  mov         acc, c3
  call        #snddat
  djnz        tx, #fillImagewLoop
  add         y,  #1
  djnz        ty, #fillImagehloop
fillImage_ret ret


''----------------------------------------------------------------------  
''cmdShowChar
'' print from ch index with attributes        ' long wide
'' @param ch - char to put                      buf[0]
'' @param fcolor - char foreground color        buf[1]
'' @param bcolor - char background color        buf[2]
'' @param mx - char left position               buf[3]
'' @param my - char top position                buf[4]

cmdShowChar

  call        #showChar
  jmp         #cmddone

showChar
  mov         tp,  bp
  rdlong      pch, tp
  add         tp,  #4
  rdlong      fgd, tp
  add         tp,  #4
  rdlong      bgd, tp
  add         tp,  #4
  rdlong      x,   tp
  add         tp,  #4
  rdlong      y,   tp

  mov         tp,  fntarr
  rdword      tp,  tp
  shl         pch, #1
  add         tp,  pch
  rdword      adr, tp           ' get char addr
  add         tp,  #2

  mov         t1, adr           ' the font is some standard made with photoshop
  mov         t2, #FONTHEIGHT   ' there are 45 bits, so we multiply by 9
  call        #multiply         ' and use div and mod to get good alignments

  mov         adr, rc
  shr         adr, #3 ' div 8

  ' at this point: lct = number of pixel lines, adr = char addr offset ptr

  mov         bit, #$80
  and         rc, #$7           ' mod 8
  shr         bit, rc           ' scan bits left to right starting at this position
                                ' subsequent bit positions start at $80
    
  rdword      fp,  fnttab       ' get font bit table pointer
  add         fp,  adr          ' char font base ptr
  mov         bits,#FONTWIDTH
  rdbyte      byt, fp           ' get first byte of char

  mov         sx,  x            ' save x
  mov         bcnt,FONT_PIXELS  ' show exactly Fnt W*H pixels
showCharBits
  sub         bcnt, #1
  call        #showp
  add         x,   #1           ' next bit position
  test        bit, #1 wz
  if_z  shr   bit, #1           ' if more bits shift mask
  if_z  jmp   #showCharSkipLd
  add         fp,  #1           ' inc ptr to get more bits
  rdbyte      byt, fp           ' get next byte of char
  mov         bit, #$80         ' else reset bit mask
showCharSkipLd
  sub         bits,#1 wz
  if_nz jmp   #showCharBits
  add         y,   #1           ' next line in char
  mov         x,   sx           ' reset x bit position
  mov         bits,#FONTWIDTH   ' number of columns = bits per row
  tjnz        bcnt,#showCharBits' show exactly 45 pixels
showCharDone  
showChar_ret  ret  

'---------------------------------
' part of show char
'
showp
  mov         tp,  bp           ' get arg passing base pointer
  test        byt, bit wz       ' if bit set
  if_nz wrlong fgd, tp          '   save foreground color
  if_z  wrlong bgd, tp          ' else save background
  if_z  tjz   bgd, showp_ret    ' if black bacground, no pixel
  add         tp,  #4 
  wrlong      x,   tp           ' save x pos
  add         tp,  #4
  wrlong      y,   tp           ' save y pos
  call        #setPix           ' set pixel
showp_ret     ret  

{
'' Get sine/cosine support - from propeller manual
'
' quadrant: 1 2 3 4
' angle:           $0000..$07FF $0800..$0FFF $1000..$17FF $1800..$1FFF
' table index:     $0000..$07FF $0800..$0001 $0000..$07FF $0800..$0001
' mirror:          +offset -offset +offset -offset
' flip:            +sample +sample -sample -sample
'
' @parm sin - on entry:  sin[12..0] holds angle (0 to just under 360)
' @return sin - on exit: sin holds signed value ranging from 
'                        $0000FFFF ('1') to $FFFF0001 ('-1')
'
getcos
  add   sin,sin_90              'for cosine, add 90
getsin
  test  sin,sin_90  wc          'get quadrant 2|4 into c
  test  sin,sin_180 wz          'get quadrant 3|4 into nz
  negc  sin,sin                 'if quadrant 2|4, negate offset
  or    sin,sin_table           'or in sin table address >> 1
  shl   sin,#1                  'shift left to get final word address
  rdword sin,sin                'read word sample from $E000 to $F000
  negnz sin,sin                 'if quadrant 3|4, negate sample
getsin_ret
getcos_ret ret                  '39..54 clocks (variance due to HUB sync on RDWORD)

sin           long 0            ' getsin getcos param/return

sin_90        long $0800
sin_180       long $1000
sin_table     long $E000 >> 1   'sine table base shifted right
}

''----------------------------------------------------------------------
'' long vars
''
PAGE_PIXELS   long ((END_PAGE*END_PAGE)/2 - 1)
FONT_PIXELS   long (FONTWIDTH*FONTHEIGHT)

''----------------------------------------------------------------------
'' registers
''
cp      res 1           ' cmd ptr
bp      res 1           ' buf ptr
fp      res 1           ' fnt ptr
tp      res 1           ' tmp ptr
cmd     res 1           ' cmd storage
adr     res 1           ' address
acc     res 1           ' accumulator
pix     res 1           ' pixel color
clr     res 1           ' pixel color
pch     res 1           ' put char index
fgd     res 1           ' foreground color
bgd     res 1           ' background color
len     res 1           ' length
ctr     res 1           ' a counter
bnum    res 1           ' buffer number 0:1, 1:2

x       res 1           ' x pos
y       res 1           ' y pos
width   res 1           ' x size
height  res 1           ' y size
outln   res 1           ' outline
sx      res 1           ' save x pos
sy      res 1           ' save y pos
tx      res 1           ' x pos
ty      res 1           ' y pos
twid    res 1           ' tmp width
thit    res 1           ' tmp height
c1      res 1           ' color 1
c2      res 1           ' color 2
c3      res 1           ' color 3
bits    res 1           ' bit count
bit     res 1           ' bit mask
byt     res 1           ' byt store
bcnt    res 1           ' number of bits
lct     res 1           ' char line count

t1      res 1           ' temporary variables
t2      res 1
rc      res 1

fntarr  res 1           ' font array ptr
fnttab  res 1           ' font table ptr

mod     res 1           ' device mode
clk     res 1           ' clock pin
cs      res 1           ' chip select pin
dio     res 1           ' device data input pin - out for us
csdclk  res 1           ' cs | dio | clk

        fit $1e0


{{
______________________________________________________________________________________________________________________________                                                                                                                                                                 

                                                   TERMS OF USE: MIT License
______________________________________________________________________________________________________________________________                                                                                                                                                                 

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation     
files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy,    
modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software
is furnished to do so, subject to the following conditions:                                                                   
                                                                                                                              
The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.
                                                                                                                              
THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE          
WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR         
COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,   
ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
______________________________________________________________________________________________________________________________
}}
                                    